<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$is_new = ($_GET['album_id'] > 0) ? false : true;
$album = new Album($_GET['album_id']);
$type  = 'user';
$id    = $user->UserID;
$owner = $user;
$ownerEntity = '';

if ($type != 'user')
{
    $template->setVariable('Entity', $type);
    $template->setVariable('EntityID',   $id);
    $template->parse('back_link');
}

if ($album->AlbumID == -1)
{
    $type = $_GET['type'] ? $_GET['type'] : $type;
    $id   = $_GET['id'] ? $_GET['id'] : $id;
    $ownerEntity    = ucfirst($type);
    $owner = new $ownerEntity($id);
}
else
{
    $owner = $album->getOwner();
    $ownerEntity    = get_class($owner);
    $type = strtolower($ownerEntity);
    $id   = $owner->{ucfirst(get_class($owner)) . 'ID'};
}

if ($owner->checkActionPermission('create_album'))
{
    $data = $album->getDataArray();
    if (isset($_POST['submitted']))
    {
        $error = false;
        foreach ($data as $key => $value)
        {
            if (isset($_POST[$key]))
            {
                   $data[$key] = $_POST[$key];
            }
            switch ($key)
            {
                case "AlbumName":
                    if (!$data[$key])
                    {
                        $error = true;
                        $template->touchBlock("err_" . $key);
                    }
                    break;
                case "AlbumDescription":
                    if (!$data[$key])
                    {
                        $error = true;
                        $template->touchBlock("err_" . $key);
                    }
                    break;
            }
        }
        $album->populateFromArray($data);
        $album->{$ownerEntity . 'ID'} = $id;
        $album->setOwner($type, $id);

        if (isset($_POST['visibleall']))
        {
            $album->AlbumPrivacy = PRIVACY_PUBLIC;
            $template->touchBlock('privacy_public');
        }
        else
        {
        	$album->AlbumPrivacy = PRIVACY_PRIVATE;
		}

        if (!$error)
        {
        	$album->saveToDB();

            Connection::clearAlbumPrivacy($album->AlbumID);
            if ($album->AlbumPrivacy == PRIVACY_PRIVATE)
            {
                foreach (array('Group', 'Organization', 'User') as $targetEntity)
                {
                    if (is_array(@$_POST[$targetEntity . 'ID']))
                    {
                        foreach ($_POST[$targetEntity . 'ID'] as $targetID)
                        {
                            $target = Entity::getObject($targetEntity, $targetID);
                            if ($target->{db_get_entity_key($target)} != -1)
                            {
                                Connection::createAlbumPrivacyConnection($album->AlbumID, $targetEntity, $targetID);
                            }
                        }
                    }
                }
            }

            if ($is_new)
            {
            	cmn_redirect('album_upload.php?album_id=' . $album->AlbumID);
            }
            else
            {
            	cmn_redirect('albums.php?type=' . $type . '&id=' . $id);
            }
        }
    }
    if ($album->AlbumPrivacy == PRIVACY_PUBLIC)
    {
        $template->touchBlock('privacy_public');
    }
    $template->setVariable($data);

 	$connections = Connection::getAlbumPrivacyConnections($album->AlbumID);
 	$checked = array();
 	foreach ($connections as $connection)
 	{
 		$target = $connection->getTarget($album);
 		if (!isset($checked[get_class($target)]))
 		{
 			$checked[get_class($target)] = array();
		}
		$id = $target->{db_get_entity_key($target)};
		$checked[get_class($target)][$id] = $id;
	}

    $control = new MyConnections('PRIVACY', 'control.myconnections_select.html');
    $control->parse($template, $user->UserID, 0, false, $checked);
}
else
{
    cmn_unauthorized_action();
}

include('includes/application_bottom.php');