<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'calendar';
require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$template->setGlobalVariable('SectionHeader', 'Calendar');

$obj = $user;

switch ($entity = ucfirst(isset($_GET['entity']) ? $_GET['entity'] : @$_GET['type']))
{
	case 'User':
	case 'Organization':
	case 'Group':
	case 'Community':
	
		$obj = Entity::getObject($entity, @$_GET['id']);      
}

if ($obj->{db_get_entity_key($obj)} != -1)
{
	if ($obj->checkCalendarPrivacy($user->UserID))
	{

        $template->setGlobalVariable('Entity', strtolower(get_class($obj)));

        $template->setGlobalVariable('EntityID', $obj->{db_get_entity_key($obj)});

        if (get_class($obj) == 'Community' || get_class($obj) == 'Group' || get_class($obj) == 'Organization')
        {
            if ($obj->userIsAdmin($user->UserID))
            {
            	$template->touchBlock('edit_panel');
			}
			$template->touchBlock('back_link');
		}

        if ((get_class($obj) == 'User') && ($obj->UserID == $user->UserID))
        {
            $template->touchBlock('sync_link');
            if (!UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_INVITATIONS))
            {
                $template->touchBlock('invite_link');
            }

            $template->touchBlock('edit_panel');
        }

		if (isset($_GET['delete']))
		{
			$event = new Event($_GET['delete']);
			if ($event->isAdmin($user->UserID))
			{
				$event->delete();
			}
		}

		$imported = array();

		if (isset($_POST['import']))
		{
			for ($i = 0; $i < count($_POST['EventName']); $i++)
			{
				$event = Event::searchEvent(get_class($obj), $obj->{db_get_entity_key($obj)},
		            $_POST['EventName'][$i],
					date('Y-m-d H:i:s', strtotime($_POST['EventStartDate'][$i])));

				if ($event->EventID == -1)
				{
					$event->EventLocationName = $_POST['EventLocationName'][$i];
					$event->EventDescription = $_POST['EventDescription'][$i];
					$event->EventEndDate = date('Y-m-d H:i:s', strtotime($_POST['EventStartDate'][$i]) + 60 * intval($_POST['EventMinutes'][$i]));
					$event->saveToDB();
				}

				$imported[$event->EventID] = $event;
			}
		}

		$arrEvents = $obj->getEvents();
		if(get_class($obj) == 'User') 
		{
			$arrEvents = array_merge($arrEvents, Event::getPublicEvents());
		}
		$arrEventsByDate = array();
		$arrEventsByID=array();

		foreach ($arrEvents as $event)
		{
			if (!isset($imported[$event->EventID]) && isset($_POST['import']))
			{
				$template->setVariable('EventName', $event->EventName);
				$template->setVariable('EventDescription', $event->EventName);
				$template->setVariable('EventLocationName', $event->EventLocationName);
				$template->setVariable('EventStartDate', date('m/d/Y h:i A', strtotime($event->EventStartDate)));
				$template->setVariable('EventMinutes', ((strtotime($event->EventEndDate) - strtotime($event->EventStartDate)) / 60));
				$template->parse('export_event');
			}

			$timestamp     = strtotime($event->EventStartDate);
			$end_timestamp = strtotime(empty($event->EventEndDate) ? $event->EventStartDate : $event->EventEndDate);

			$timestamp = mktime(0, 0, 0, date("m", $timestamp),
				date("d", $timestamp), date("Y", $timestamp));

			$end_timestamp = mktime(0, 0, 0, date("m", $end_timestamp),
				date("d", $end_timestamp), date("Y", $end_timestamp));

			$event->Days = 0;

			while ($timestamp <= $end_timestamp)
			{
				$event_date = date('Y-m-d', $timestamp);
				if (!isset($arrEventsByDate[$event_date]))
				{
					$arrEventsByDate[$event_date] = array();
				}
				$arrEventsByDate[$event_date][] = $event;

				$timestamp = mktime(0, 0, 0, date("m", $timestamp), date("d", $timestamp) + 1, date("Y", $timestamp));
				$event->Days++;
			}

		}


		$month	= isset($_GET['month']) ? $_GET['month'] : date('m');
		$year	= isset($_GET['year']) ? $_GET['year'] : date('Y');

		$time = mktime(0, 0, 0, $month, 1, $year);
		$template->setVariable('Month', date('F', $time));
		$template->setVariable('Year', date('Y', $time));

		$next = mktime(0, 0, 0, date('m', $time) + 1, 1, date('Y', $time));
		$prev = mktime(0, 0, 0, date('m', $time) - 1, 1, date('Y', $time));

		$template->setVariable('NextMonth', date('m', $next));
		$template->setVariable('NextYear', date('Y', $next));

		$template->setVariable('PrevMonth', date('m', $prev));
		$template->setVariable('PrevYear', date('Y', $prev));

		$first = get_first_day($year, $month);
		$last = get_days($year, $month);

		$today_date=sprintf('%d-%02d-%02d', date('Y'), date('m'), date('d'));
		$day=0;
		for ($i = 1; $i <= 6; $i++) //can be 6 weeks in month
		{
			if($day>$last) {
				break; //don't show if 6 week is empty
			}
			for ($j = 1; $j <= 7; $j++)
			{
				if ($first == $j)
				{
					$first	= 0;
					$day	= 1;

					if ($j > 6)
					{
						$i--;
					}
				}
				if ($first || $day > $last)
				{
					$template->touchBlock('no_day');
				}
				else
				{
					$date = sprintf('%d-%02d-%02d', $year, $month, $day);
					if ($date == $today_date)
					{
						$template->touchBlock('today');
					}

					if (isset($arrEventsByDate[$date]))
					{
						foreach ($arrEventsByDate[$date] as $event)
						{
							if(!isset($arrEventsByID[$event->EventID]))
							{
								$template->setVariable('EventID',	 $event->EventID);
								$template->setVariable('EventName',	 $event->EventName);

								if ($event->Days > 1)
								{
									$template->setVariable('EventTime', tpl_date_format($event->EventStartDate, 'Y/m/d h:i A') .
										' - ' . tpl_date_format($event->EventEndDate, 'Y/m/d h:i A'));
								}
								else
								{
									$template->setVariable('EventTime', tpl_date_format($event->EventStartDate, 'Y/m/d').
									        ' - ' . tpl_date_format($event->EventStartDate, 'h:i A') .
										' - ' . tpl_date_format($event->EventEndDate, 'h:i A'));
								}
                                                        	if ($event->isAdmin($user->UserID))
								{
									$template->touchBlock('edit_delete');
								}
						                 $arrEventsByID[$event->EventID] = $event->EventID;
								 $template->parse('event');
							}
							$template->setVariable('EventID',	 $event->EventID);
							$template->setVariable('event', 'event');
							$template->touchBlock("daylink_start");
							$template->touchBlock("daylink_end");
						}
					}
					$template->setVariable('Day', $day);
					$template->parse('day');
				}
				$day++;
				$template->parse('cell');
			}
			$template->parse('week');
		}
	}
}

function get_days($year, $month)
{
    for ($i = 31; $i > 27; $i--)
        if (checkdate($month, $i, $year)) return $i;
}

function get_first_day($year, $month)
{
    if (!checkdate($month, 1, $year)) return -1;
    $tdate = strtotime($year . "-" . $month . "-1");
    return date("w", $tdate) + 1;
}

require_once('includes/application_bottom.php');