<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'my_connections';
include('includes/application_top.php');
if ($user->isAuthorised())
{
    if (UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_INVITATIONS))
    {
        cmn_unathorized_action();
    }
    
    $obj = Entity::getObject(@$_GET['entity'], @$_GET['id']);
    switch (get_class($obj))
    {
        case 'User':
        case 'Group':
        case 'Organization':
            break;
            
        default:
            $obj = $user;
    }
    
    $template->setGlobalVariable('ObjectEntity', strtolower(get_class($obj)));
    $template->setGlobalVariable('ObjectID', $obj->{db_get_entity_key($obj)});
    
	switch ($_POST['submited'])
	{
		case 'import':
		
            
			if (is_array($_POST['UserID']))
			{
				for ($i = 0; $i < count($_POST['UserID']); $i++)
				{    
                    $invited = new User($_POST['UserID'][$i]);
					if ($invited->UserID == -1)
					{
                        
						$invited->UserEmail		= $_POST['Email'][$i];
						$invited->UserType		= USER_TYPE_INVITED;
						$invited->Password		= cmn_generate_password();
						$invited->saveToDB();
						
						$tpl = Message::getMessageTemplate('contacts_invite.html');
						
						$tpl->setVariable('Message', htmlspecialchars(stripslashes(sprintf("%s", $_POST['txtMessage']))));
						$tpl->setVariable('UserFirstname', $user->UserFirstname);
						$tpl->setVariable('UserLastname', $user->UserLastname);
                        $tpl->setVariable('ConnectID', $obj->{db_get_entity_key($obj)});
                        $tpl->setVariable('ConnectEntity', strtolower(get_class($obj)));
						$tpl->setVariable('UserID', $invited->UserID);
						echo $tpl->get();
						Message::sendEmail($invited->UserEmail, 'Community Invitation', $tpl->get());
						$invitation = new SentInvitation();
						$invitation->SentInvitationEmail = $invited->UserEmail;
						$invitation->{get_class($obj) . 'ID'} = $obj->{db_get_entity_key($obj)};
						$invitation->saveToDB();
					}
					else
					{
						if ($invited->UserType != USER_TYPE_INVITED)
						{
				            switch (get_class($obj))
                            {
                                case 'User':
                                    $obj->sendBuddyRequest($_POST['UserID'][$i], @$_POST['Message']);
                                    break;
                                
                                case 'Organization':    
                                case 'Group':
                                    $obj->inviteMember($user->UserID, $_POST['UserID'][$i], @$_POST['Message']);
                            }
                            
						}
					}
				}
			}
			
			$template->touchBlock(($_GET['source'] == 'outlook' ? 'outlook_' : '') . 'import_ok');
			break;
	}
	
	switch ($_GET['source'])
	{
		case 'yahoo':
			$template->setGlobalVariable('Service', 'Yahoo!');
			$template->setGlobalVariable('Domain', 'yahoo.com');
			$template->touchBlock('yahoo_checked');
			import('GrabYahoo');
			break;
    	
    	case 'gmail':
			$template->setGlobalVariable('Service', 'Gmail');
			$template->setGlobalVariable('Domain', 'gmail.com');
			$template->touchBlock('gmail_checked');
			import('GMailer');
			break;
			
    	case 'outlook':
    		$template->setGlobalVariable('Service', 'Outlook');  
			$template->touchBlock('outlook_checked');
			outlook();
			break;	
	}
}
else
{
    cmn_unathorized_action();
}

function outlook()
{
	global $template;
	$extensions = array('csv', 'txt', 'vcf');

	if (is_uploaded_file($_FILES['fileOutlook']['tmp_name']))
	{
		$path_info = pathinfo($_FILES['fileOutlook']['name']);
		if (in_array(strtolower($path_info['extension']), $extensions))
		{
			$content = file_get_contents($_FILES['fileOutlook']['tmp_name']);
			$matches = array();
			
			$template->touchBlock('contacts'); 
			
			if (preg_match_all('/[0-9a-z_\.\-]+@[0-9a-z_^\.\-]+\.[a-z]{2,3}/i', $content, $matches))
			{		
				$emails = array();			
				foreach ($matches[0] as $email)
				{                                     
					$emails[$email] = $email;
				}
				foreach ($emails as $email)
				{
					$template->setVariable('Email', $email);
					$template->setVariable('Name', '');
					$member = User::getByUserEmail($email);
					$template->setVariable('UserID', $member->UserID);
					$template->parse('imported');
				}
			}
			else
			{
				$template->touchBlock('outlook_no_address');
			}
		}
		else
		{
			$template->touchBlock('extension_error');
		}
	}
	else
	{
		$template->touchBlock('outlook');
	}

}

function import($class)
{
	global $template, $user;
	if (@$_POST['submited'] == 'login')
	{
		$obj = new $class();
        $contacts = $obj->getAddressbook($_POST['Username'], $_POST['Password']);
		
		if ($contacts !== false)
		{
			$template->touchBlock('contacts');
			for ($i = 0; $i < count($contacts['name']); $i++)
			{
				$template->setVariable('Email', $contacts['email'][$i]);
				$template->setVariable('Name', $contacts['name'][$i]);
				$member = User::getByUserEmail($contacts['email'][$i]);
				$template->setVariable('UserID', ($member->UserType != USER_TYPE_INVITED ? $member->UserID : -1));
				$template->parse('imported');
			}
		}
		else
		{
			$template->touchBlock('login_error');
		}
	}
	else
	{
		$template->touchBlock('login');
	}  
	$template->setGlobalVariable('UserFirstname', $user->UserFirstname);
	$template->setGlobalVariable('UserLastname', $user->UserLastname);
}


include('includes/application_bottom.php');
?>