<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'files';
require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

if (UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_MEDIA))
{
    cmn_unauthorized_action();
}

$type   = $_GET['type'] ? $_GET['type'] : 'user';
$id     = $_GET['id'] ? $_GET['id'] : $user->UserID;
$owner_id = $id;

if ($type != 'user')
{
	switch ($type)
	{
		case 'group':
		case 'organization':
		case 'community':

			$owner = Entity::getObject($type, $id);

	        if (!$owner->userIsAdmin($user->UserID) && ($owner->{ucfirst($type) . 'Permissions'} & PERMISSION_ALLOW_FILES) != PERMISSION_ALLOW_FILES)
	        {
	            cmn_unauthorized_action();
	        }
	        $template->setVariable('Entity', $type);
	        $template->setVariable('EntityID', $id);
	        $template->parse('back_link');
			break;

		default:
			cmn_unauthorized_action();
	}
}
else
{
    if ($user->UserID != $id)
    {
        cmn_unauthorized_action();
    }
}

$template->setVariable('type', $type);
$template->setVariable('id',   $id);

if ($type && $id)
{
	$class = ucfirst($type);
    $owner = new $class($id);

    if ($owner->checkActionPermission('edit'))
    {
        if ($_POST['action'] == 'upload')
        {
            $path = './tmp/' . $type . 'files/' . $id . '/';
            cmn_create_path($path, false);
            $d = dir($path);
            $files = array();
            while (false !== ($file = $d->read()))
            {
                if ($file != '.' && $file != '..')
                {
                    $pathinfo = pathinfo($file);

                    $sfile = new File();
                    $sfile->{$class . 'ID'} = $id;
                    $sfile->FilePath = time() . $pathinfo['basename'];
                    $sfile->FileName = $pathinfo['basename'];
                    $sfile->{$class . 'ID'} = $id;
                    $sfile->saveToDB();

                    cmn_create_path(PATH_FILES . $type . '/' . $id, false);
                    rename($path . $file, PATH_FILES . $type . '/' . $id . '/' . $sfile->FilePath);

                    $sfiles[] = $sfile;
                }
            }
            foreach ($sfiles as $file)
            {
                 $template->setVariable('FileID',           $file->FileID);
                 $template->setVariable('FileName',         $file->FileName);
                 $template->setVariable('FileThumbnail',    $file->getFileURL(true));
                 $template->parse('file_line');
            }
            $template->hideBlock('upload_form');
            $template->touchBlock('files_form');
        }
        else if ($_POST['action'] == 'save')
        {
        	if (is_array($_POST['FileName']))
            foreach ($_POST['FileName'] as $id => $name)
            {
                $file = new File($id);
                if (isset($_POST['delfile'][$id]))
                {
                    $file->delete();
                    continue;
                }

                $file->FileName = $name;
                $file->saveToDB();
            }
            cmn_redirect('files.php?type=' . $type . '&id=' . $owner_id);
        }
        else
        {
            $template->setVariable('session_id', session_id());
            $template->touchBlock('upload_form');
            $template->touchBlock('steps');
        }
    }
    else
    {
        cmn_unauthorized_action();
    }
}
else
{
    cmn_unauthorized_action();
}

require_once('includes/application_bottom.php');