<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$form_id = isset($_GET['form_id']) ? $_GET['form_id'] : ( isset($_POST['FormID']) ? $_POST['FormID'] : -1 );
$form = new Form($form_id);

// create form
if ($form->FormID == -1)
{
	$entity = isset($_GET['entity']) ? $_GET['entity'] : ( isset($_POST['Entity']) ? $_POST['Entity'] : 'Group');
	$id = isset($_GET['id']) ? $_GET['id'] : ( isset($_POST['ID']) ? $_POST['ID'] : -1 );

	$object = Entity::getObject($entity, $id);
}
// edit form
else
{
	$object = $form->getOwner();
	$entity = ucfirst(get_class($object));
	$id = $object->{db_get_entity_key($object)};
}

if ( ($object->{db_get_entity_key($object)} == -1) || (!$object->hasMember($user->UserID)) )
{
	cmn_unauthorized_action();
}

$data = $form->getDataArray();

if ($_POST['action'] == 'save')
{
	$error = false;

	if (!empty($_POST))
	{
		foreach ($data as $key => $field)
		{
			if (isset($_POST[$key]))
			{
				$data[$key] = $_POST[$key];
			}
		}
	}

	if (empty($data['FormName']))
	{
		$error = true;
		$template->touchBlock('FormName_empty');
	}
	elseif (empty($data['FormDescription']))
	{
		$error = true;
		$template->touchBlock('FormDescription_empty');
	}
	elseif (is_array($_POST['FormFieldName']))
	{
		foreach ($_POST['FormFieldName'] as $field_name)
		{
			if (empty($field_name))
			{
				$error = true;
				$template->touchBlock('FormFieldName_empty');
				break;
			}
		}
	}
	else
	{
		$error = true;
		$template->touchBlock('FormFields_absent');
	}

	if (!$error)
	{
		$form->populateFromArray($data);
		$form->{db_get_entity_key($object)} = $id;
		$form->saveToDB();

		// saving form fields
		if (is_array($_POST['FormFieldName']))
		{
			foreach ($_POST['FormFieldName'] as $field_id => $field_name)
			{
				$form_field = new FormField($field_id);
				if ($form_field->FormID != $form_id)
				{
					$form_field = new FormField(-1);
				}
				$form_field->FormID = $form->FormID;
				$form_field->FormFieldName = $_POST['FormFieldName'][$field_id];
				$form_field->FormFieldType = $_POST['FormFieldType'][$field_id];
				$form_field->saveToDB();

		        // saving form field options
		        if ($form_field->FormFieldType == FORM_FIELD_TYPE_MULTIPLE)
		        {
	        		$form_field->clearFormFieldOptions();
	        		if (is_array($_POST['FormFieldOptionValue'][$field_id]))
	        		{
						foreach ($_POST['FormFieldOptionValue'][$field_id] as $option_id => $option_value)
						{
							$option = new FormFieldOption(-1);
							$option->FormFieldID = $form_field->FormFieldID;
							$option->FormFieldOptionValue = $option_value;
							$option->saveToDB();
						}
					}
				}
			}
		}

		cmn_redirect('manage_forms.php?entity=' . $entity . '&id=' . $id);
	}
}
elseif ( ($_POST['action'] == 'delete_field') && (!empty($_POST['FormFieldID'])) )
{
	$form_field = new FormField($_POST['FormFieldID']);
	$form_field->delete();
}

$template->setVariable('FormName', $form->FormName);
$template->setVariable('FormDescription', $form->FormDescription);
$template->setVariable('FormStartDate', $form->FormStartDate);
$template->setVariable('FormEndDate', $form->FormEndDate);

if ($form->FormID == -1)
{
	$form->FormPrivacy = $_POST['FormPrivacy'];
}
if ($form->FormPrivacy == PRIVACY_PUBLIC)
{
	$template->setVariable('public_selected', 'checked');
}
else
{
	$template->setVariable('private_selected', 'checked');
}

$form_fields = $form->getFormFields();
foreach ($form_fields as $field)
{
    $template->setVariable('FormFieldID', $field->FormFieldID);
    $template->setVariable('FormFieldName', $field->FormFieldName);
    $template->setVariable('FormFieldType', $field->FormFieldType);

    $options = FormFieldOption::getFormFieldOptions($field->FormFieldID);
    $form_field_option_values = '';
    $form_field_option_indices = '';
    foreach ($options as $option)
    {
    	$form_field_option_values .= '\'' . $option->FormFieldOptionValue . '\', ';
    	$form_field_option_indices .= '\'' . $option->FormFieldOptionID . '\', ';
	}
	$form_field_option_values = rtrim($form_field_option_values, ', ');
	$form_field_option_indices = rtrim($form_field_option_indices, ', ');

    $template->setVariable('FormFieldOptionIndices', $form_field_option_indices);
    $template->setVariable('FormFieldOptionValues', $form_field_option_values);

	$template->parse('add_field');
}

if ($form->FormID != -1)
{
    $template->setVariable('FormID', $form->FormID);
	$template->parse('request_link');
}

$template->setVariable('FormID', $form->FormID);
$template->setVariable('Entity', $entity);
$template->setVariable('ID', $id);

$template->setVariable($data);

require_once('includes/application_bottom.php');