<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

// for admin purposes
if (isset($_GET['group_id']) && User::checkEmployer($_SESSION['user']->UserID) && !isset($_GET['in']))
{
    $group = new Group($_GET['group_id']);
    $user = $group->getOwner();
    $_SESSION['admin_rule'] = $user;
    cmn_redirect('group.php?group_id=' . $_GET['group_id'] . '&in'); // re-process header blocks and menu
}


$group_id = isset($_GET['group_id']) ? $_GET['group_id'] : ( isset($_POST['group_id']) ? $_POST['group_id'] : -1 );
$group = new Group($group_id);

if ($group->GroupID != -1)
{

    if ($group->GroupStatus == GROUP_STATUS_PRIVATE)
    {
        if (!$group->hasMember($user->UserID))
        {
            cmn_unauthorized_action();
        }
    }
	if ($group->isBlocked($user))
	{
		cmn_unauthorized_action();
	}
	if ($group->isMemberBlocked($user->UserID))
	{
		cmn_unauthorized_action();
	}

	// non-for-profit verification
	if ($group->GroupIsNonForProfit)
	{
		$template->touchBlock('non_for_profit_icon');
	}

	// members Update
	$new_members_count = $group->getNewMembersCount();
	if ($new_members_count > 0)
	{
		$template->setVariable('NewMembersCount', $new_members_count);
		$template->parse('new_members');
	}
	// news Update
	$new_news_count = $group->getNewNewsCount();
	if ($new_news_count > 0)
	{
		$template->setVariable('NewNewsCount', $new_news_count);
		$template->parse('new_news');
	}

	// photos Update
	$new_photos_count = $group->getNewPhotosCount();
	if ($new_photos_count > 0)
	{
		$template->setVariable('NewPhotosCount', $new_photos_count);
		$template->parse('new_photos');
	}

	// videos Update
	$new_videos_count = $group->getNewVideosCount();
	if ($new_videos_count > 0)
	{
		$template->setVariable('NewVideosCount', $new_videos_count);
		$template->parse('new_videos');
	}

	// shared files Update
	$new_files_count = $group->getNewFilesCount();
	if ($new_files_count > 0)
	{
		$template->setVariable('NewFilesCount', $new_files_count);
		$template->parse('new_files');
	}

	if ($group->userIsAdmin($user->UserID))
	{
		$template->touchBlock('edit_link');
		//$template->touchBlock('members_link');
		$template->touchBlock('todo_link');
	}
	elseif ($group->hasMember($user->UserID))
	{
		$template->touchBlock('todo_link');
	}
    
    if ($group->userIsAdmin($user->UserID) || $group->GroupStatus == GROUP_STATUS_PUBLIC && $group->hasMember($user->UserID))       
    {
        $template->touchBlock('add_files');
        $template->touchBlock('add_videos');
        $template->touchBlock('add_photos');
        $template->touchBlock('add_news');
    }
    else
    {
        $template->hideBlock('add_files');
        $template->hideBlock('add_videos');
        $template->hideBlock('add_photos');
        $template->hideBlock('add_news');
    
    }
	$template->setVariable(get_object_vars($group));

	$owner = $group->getOwner();
    if (is_a($owner, "Organization"))
    {
        $owner = new User($owner->getOwnerID());
    }

    $ownerconnection = $group->getOwnerConnection();
    $template->setVariable("grCreationDate", $ownerconnection->Created);

    $template->setVariable(get_object_vars($owner));
    $template->setVariable("creator_name", $owneruser->UserFirstname . ' ' . $owneruser->UserLastname);
    $template->setVariable("creator_id", $owneruser->UserID);

    $organizations = $group->getConnectedOrganizationInfo();
    $template->setVariable("OrgCount", count($organizations) );
    foreach ($organizations as $corg)
    {
        $template->setVariable("OrganizationID", $corg['OrganizationID']);
        $template->setVariable("OrganizationName", $corg['OrganizationName']);
    }


	$data = $group->getDataArray();
	$data['GroupID'] = $group->GroupID;
    if ($group->checkViewNewsPrivacy())
    {
        $allnews = $group->getGroupNews();
        if (!empty($allnews))
        {
            foreach ($allnews as $news)
            {
                if ( ($news->NewsViewingPrivacy == PRIVACY_PUBLIC) || ($group->hasMember($user->UserID)) )
                {
                    $template->setVariable("NewsName", $news->NewsName);
                    $template->setVariable("NewsText", $news->NewsText);
                    $template->setVariable("NewsDate", $news->NewsDate);
                    $template->parse("news");
                }
            }
        }
        else
        {
            $template->touchBlock('no_news');
        }    
    }
    else
    {
        $template->hideBlock('group_news');            
    }

	$template->setVariable('NewsCount', count($allnews));
	$template->setVariable('MembersCount', $group->getGroupMembersCount());
	$template->setVariable('AlbumsCount', $group->getAlbumsCount());

	$groupphotos = $group->getGroupPhotos(6);
	if (count($groupphotos))
	{
		$template->touchBlock("allphotos_link");
		foreach ($groupphotos as $photo)
		{
			$template->setVariable("PhotoName", $photo->PhotoName);
			$template->setVariable("ImgURL", $photo->getPhotoURL());
			$template->setVariable("PhotoID", $photo->PhotoID);
			$template->parse("photo");
		}
	}
    else
    {
        $template->touchBlock("no_photo");
    }

	$groupvideos = $group->getGroupVideos(6);
	if (count($groupvideos))
	{
		$template->touchBlock("allvideos_link");
		foreach ($groupvideos as $video)
		{
			/*
			$template->setVariable("VideoName", $video->VideoName);
			$pathinfo = pathinfo($video->VideoPath);
			$template->setVariable("VideoIconURL", PATH_FILEICONS_PICS . "/" . $pathinfo['extension'] . "." . FILEICONS_EXT);
			$template->setVariable("ImgURL", PATH_VIDEOS . "/" . $ownerid . "/" . $video->VideoPath);
			*/
	        $template->setVariable(get_object_vars($video));
	        $template->setVariable('VideoURL', $video->getVideoURL());
			$template->parse("video");
		}
	}
    else
    {
        $template->touchBlock("no_video");
    }

	$groupfiles = $group->getSharedFiles(6);
	if (count($groupfiles))
	{
		$template->touchBlock("allfiles_link");
		foreach ($groupfiles as $file)
		{
			/*
			$template->setVariable("FileName", $file->FileName);
			$pathinfo = pathinfo($file->FilePath);
			$template->setVariable("FileIconURL", PATH_FILEICONS_PICS . "/" . $pathinfo['extension'] . "." . FILEICONS_EXT);
			$template->setVariable("SharedFileID", $file->SharedFileID);*/
        	$template->setVariable(get_object_vars($file));
        	$template->setVariable('SharedFileURL', $file->getFileURL());
			$template->parse("file");
		}
	}
    else
    {
        $template->touchBlock("no_file");
    }

	$template->setVariable($data);
    $template->setGlobalVariable('GroupID', $group->GroupID);
	if ($group->GroupPicture)
	{
		$template->setVariable("GroupPictureURL", PATH_GROUP_PICS . $group->GroupID . '/80px/' . $group->GroupPicture);
	}
	else
	{
		$template->setVariable("GroupPictureURL", 'images/img.jpg');
	}

	if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/wiki/');
	require_once(DOKU_INC.'inc/init.php');
	require_once(DOKU_INC.'inc/common.php');
	require_once(DOKU_INC.'inc/events.php');
	require_once(DOKU_INC.'inc/pageutils.php');
	require_once(DOKU_INC.'inc/html.php');
	require_once(DOKU_INC.'inc/auth.php');
	require_once(DOKU_INC.'inc/actions.php');
	$id = cleanID($group->GroupName);
	$template->setVariable("WikiName", 'Groups:' . $id . ':start');

	$template->setVariable("GroupStatus", $GROUP_STATUS_LABELS[$group->GroupStatus]);
	$template->setVariable("GroupName", $group->GroupName);
	$template->setVariable("GroupMembersCount", $group->getGroupMembersCount());

	// new connection people statistics
	$new_connection_people = $group->getGroupMembersCount();
	$individuals_count = User::getAllUsersCount();
	$rank = $individuals_count > 0 ? sprintf("%d", $new_connection_people / $individuals_count * 100) : 0;
	$template->setVariable('NewConnectionPeople', $new_connection_people);
	$template->setVariable('NewConnectionPeopleRank', $rank);

	// member files uploaded statistics
	$uploaded_files_count = count($group->getSharedFiles());
	$all_files = count(SharedFile::getAll('SharedFile'));
	$rank = ($all_files == 0) ? 0 : sprintf("%d", $uploaded_files_count / $all_files * 100);
	$template->setVariable('FilesUploadedCount', $uploaded_files_count);
	$template->setVariable('FilesUploadedRank', $rank);

	// tags statistics
	$tags_count = count($group->getTags());
	$all_tags = count(Tag::getAll('Tag'));
	$rank = $all_tags > 0 ? sprintf("%d", $tags_count / $all_tags * 100) : 0;
	$template->setVariable('TagsCount', $tags_count);
	$template->setVariable('TagsRank', $rank);

	// photo/video uploads statistics
	$photo_video_count = $group->getVideoCount() + $group->getPhotoCount();
	$all_photo_videos = count(Photo::getAll('Photo')) + count(Video::getAll('Video'));
	$rank = $all_photo_videos > 0 ? sprintf("%d", $photo_video_count / $all_photo_videos * 100) : 0;
	$template->setVariable('PhotosVideosCount', $photo_video_count);
	$template->setVariable('PhotosVideosRank', $rank);

	// organization connections
	$connections = $group->getConnections(array('OrganizationID' => '<> -1', 'GroupID' => $group->GroupID), array('Created'));
	$template->setVariable('OrganizationsCount', count($connections));
	for ($i = 0; $i < count($connections) && $i < 10; $i++)
	{
	    $connection = $connections[$i];
	    $organization = $connection->getOrganization();
		$template->setVariable('OrganizationID', $organization->OrganizationID);
		$template->setVariable('OrganizationName', $organization->OrganizationName);
		if ( ( ($connection->ConnectionType == CONNECTIONTYPE_OWNER) || ($connection->ConnectionType == CONNECTIONTYPE_ADMIN) ) && $user->UserID == $member->UserID)
		{
			$template->touchBlock('organization_manage');
		}
		$template->parse('gr_organization');
	}

	// group connections
	$connections = $group->getConnections(array('GroupID' => $group->GroupID, 'ToGroupID' => '<> -1'), array('Created'));
	$template->setVariable('GroupsCount', count($connections));
	for ($i = 0; $i < count($connections) && $i < 10; $i++)
	{
	    $connection = $connections[$i];
		$group = new Group($connection->ToGroupID);
		$template->setVariable('ToGroupID', $group->GroupID);
		$template->setVariable('GroupName', $group->GroupName);
		if ( ( ($connection->ConnectionType == CONNECTIONTYPE_OWNER) || ($connection->ConnectionType == CONNECTIONTYPE_ADMIN) ) && $user->UserID == $member->UserID)
		{
			$template->touchBlock('group_manage');
		}

		$template->parse('gr_group');
	}
}
else
{
	cmn_unauthorized_action();
}

include('includes/application_bottom.php');