<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');

$template->loadTemplateFile('group_avatar_popup.html');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$group_id = $_REQUEST['group_id'];
$group = new Group($group_id);

if (isset($_POST['submited']))
{
	$thumb = null;

	if (@$_POST['avatar'] != '')
	{
		$photo = new Photo($_POST['avatar']);
		if ($photo->PhotoID != -1)
		{
			$thumb = new Thumbnail($photo->PhotoPath);
		}
	}
	else
	{
		if (is_uploaded_file($_FILES['uploadedPic']['tmp_name']))
		{
			$path_info = pathinfo($_FILES['uploadedPic']['name']);

			if ($_FILES['uploadedPic']['size'] > MAX_AVATAR_SIZE)
			{
				$template->touchBlock('larger_size_error');
			}
			elseif (!in_array(strtolower($path_info['extension']), $PIC_EXTENSIONS))
			{
				$template->touchBlock('ext_error');
			}
			else
			{
				$thumb = new Thumbnail($_FILES['uploadedPic']['tmp_name']);
				$thumb->setNewFilename($path_info['basename']);
			}
			$template->touchBlock('form');
		}
	}

	if (!is_null($thumb))
	{
		cmn_remove_directory(PATH_GROUP_PICS . $group->GroupID . '/80px');
		$thumb->setSavePath(PATH_GROUP_PICS . '/' . $group->GroupID . '/80px');
		$thumb->setDimension(150, 150);
		$thumb->resize();

		cmn_remove_directory(PATH_GROUP_PICS . $group->GroupID . '/50px');
		$thumb->setSavePath(PATH_GROUP_PICS . '/' . $group->GroupID . '/50px');
		$thumb->setDimension(50, 50);
		$thumb->resize();

		$template->setVariable('groupid',	$group->GroupID);
		$template->setVariable('uploaded',	$thumb->Filename);

		$group->GroupPicture = $thumb->Filename;
		$group->saveToDB();

		$template->touchBlock('close_window');
	}
}
else
{
	$albums = $group->getGroupAlbums();

	foreach ($albums as $album)
	{
		$photos = $album->getPhotos();

		foreach ($photos as $photo)
		{
			$template->setVariable('PhotoID',	$photo->PhotoID);
			$template->setVariable('PhotoName',	$photo->PhotoName);
			$template->setVariable('AlbumName',	$album->AlbumName);
			$template->parse('Photo');
		}
	}
	if ($group->GroupPicture != '')
	{
		$template->setVariable('GroupPicture', $group->GroupPicture);
	}
	$template->touchBlock('form');
}

include('includes/application_bottom.php');