<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$group_id = isset($_GET['group_id']) ? $_GET['group_id'] : ( isset($_POST['GroupID']) ? $_POST['GroupID'] : -1 );
$group = new Group($group_id);

if (!$group->userIsAdmin($user->UserID))
{
	cmn_unauthorized_action();
}

if ($_POST['submitted'])
{
	$group->setNewsViewPrivacySettings($_POST['view_privacy']);
	$group->setNewsEditPrivacySettings($_POST['edit_privacy']);
}

$template->setVariable('PRIVACY_PUBLIC', PRIVACY_PUBLIC);
$template->setVariable('PRIVACY_PRIVATE', PRIVACY_PRIVATE);

$template->setVariable('NEWS_PRIVACY_PUBLIC', NEWS_PRIVACY_PUBLIC);
$template->setVariable('NEWS_PRIVACY_ADMINS', NEWS_PRIVACY_ADMINS);
$template->setVariable('NEWS_PRIVACY_MEMBERS', NEWS_PRIVACY_MEMBERS);

$group_view_ps = $group->getNewsViewPrivacySettings();
switch ($group_view_ps)
{
	case PRIVACY_PUBLIC:
		$template->setVariable('view_public_checked', 'checked');
	break;
    case PRIVACY_PRIVATE:
		$template->setVariable('view_private_checked', 'checked');
	break;
}
$group_edit_ps = $group->getNewsEditPrivacySettings();
switch ($group_edit_ps)
{
	case NEWS_PRIVACY_PUBLIC:
		$template->setVariable('edit_public_checked', 'checked');
	break;
    case NEWS_PRIVACY_ADMINS:
		$template->setVariable('edit_admins_checked', 'checked');
	break;
    case NEWS_PRIVACY_MEMBERS:
		$template->setVariable('edit_members_checked', 'checked');
	break;
}

$template->setVariable('GroupID', $group_id);

require_once('includes/application_bottom.php');