<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

if (ApplicationContext::getLastVisitedPage() == "group_register.php")
{
	$template->touchBlock('success');
}

$group_id = isset($_GET['group_id']) ? $_GET['group_id'] : ( isset($_POST['group_id']) ? $_POST['group_id'] : -1 );
$group = new Group($group_id);

if (($group->GroupID == -1) || (!$group->userIsAdmin($user->UserID)))
{
	cmn_unauthorized_action();
}

$data = $group->getDataArray();
$data['GroupID'] = $group->GroupID;

$other_social_groups = $group->getOtherSocialGroups();
foreach ($other_social_groups as $key => $object)
{
	$data['SocialGroupName'][] = $object->SocialGroupName;
	$data['SocialGroupURL'][] = $object->SocialGroupURL;
}

$locations = $group->getGroupLocations();
foreach ($locations as $key => $object)
{
	$data['LocationID'][] = $object->LocationID;
	$data['LocationCountry'][] = $object->LocationCountry;
	$data['LocationName'][] = $object->LocationName;
	$data['LocationStreet'][] = $object->LocationStreet;
	$data['LocationCity'][] = $object->LocationCity;
	$data['LocationState'][] = $object->LocationState;
}

if ($_POST['submitted'] == 'true')
{
	if ($_POST['action'] == 'Delete Group')
	{
		$group->suicide();
		cmn_redirect('group_register.php');
	}

    $error = false;
    foreach ($data as $key => $field)
    {
        if (isset($_POST[$key]))
        {
            $data[$key] = $_POST[$key];
        }

        switch ($key)
        {
            case "GroupDescription":
                if ($data[$key] == '')
                {
                    $error = true;
                    $template->touchBlock("err_" . $key);
                }
                break;
        }
    }

    if (!$error)
    {
    	  	
    	$group->populateFromArray($data);
    	
		$id = wiki_translate('Groups:' . $group->GroupName);
		if ($group->GroupStatus == GROUP_TYPE_PUBLIC)
		{
			wiki_delete_perm($id . ':*', '@ALL');
			wiki_delete_perm($id . ':*', '@' . auth_nameencode('Group:' . $group->GroupName));
			wiki_set_perm($id . ':*', '@ALL', 8);
		}
		else if ($group->GroupStatus == GROUP_TYPE_CLOSED)
		{
			wiki_delete_perm($id . ':*', '@ALL');
			wiki_delete_perm($id . ':*', '@' . auth_nameencode('Group:' . $group->GroupName));
			wiki_set_perm($id . ':*', '@' . auth_nameencode('Group:' . $group->GroupName), 8);
			wiki_set_perm($id . ':*', '@ALL', 1);
		}
		else 
		{
			wiki_delete_perm($id . ':*', '@ALL');
			wiki_delete_perm($id . ':*', '@' . auth_nameencode('Group:' . $group->GroupName));
			wiki_set_perm($id . ':*', '@' . auth_nameencode('Group:' . $group->GroupName), 8);
			wiki_set_perm($id . ':*', '@ALL', 0);
		}
    	
        $template->touchBlock("success");
        $group->saveToDB();

		for ($i = 0; $i < count($data['LocationName']); $i++)
		{
			$location = new Location();
			$location->GroupID			= $group->GroupID;
			$location->OrganizationID	= -1;
			$location->LocationID		= $data['LocationID'][$i];
			$location->LocationCountry	= $data['LocationCountry'][$i];
			$location->LocationName		= $data['LocationName'][$i];
			$location->LocationStreet	= $data['LocationStreet'][$i];
			$location->LocationCity		= $data['LocationCity'][$i];
			$location->LocationState	= $data['LocationState'][$i];
			$location->saveToDB();
		}

		$data['SocialGroupName'] = $_POST['SocialGroupName'];
		$data['SocialGroupURL'] = $_POST['SocialGroupURL'];

		SocialGroup::clearOtherSocialGroups($group->GroupID);
		for ($i = 0; $i < count($data['SocialGroupName']); $i++)
		{
			$other_social_group = new SocialGroup();
			$other_social_group->GroupID = $group->GroupID;
			$other_social_group->SocialGroupName = $data['SocialGroupName'][$i];
			$other_social_group->SocialGroupURL = $data['SocialGroupURL'][$i];
			$other_social_group->saveToDB();
		}

		if (isset($_POST['UserID']) && is_array($_POST['UserID']))
		{
			foreach ($_POST['UserID'] as $key => $value)
			{
				$invitation = new Invitation();
				$invitation->GroupID = $group->GroupID;
				$invitation->FromUserID = $user->UserID;
				$invitation->ToUserID = $key;
				$invitation->InvitationPermissions = CONNECTIONTYPE_MEMBER;
				$invitation->saveToDB();

				$messageText = 'Join my group';
				$connection_type = MESSAGE_GROUP_INVITE_MEMBER;
				Message::sendGroupInvite($user->UserID, $group->GroupID, $key, $messageText, $connection_type);
			}
		}
    }
    else
    {
        $template->touchBlock('if_submitted');

        for ($i = 0; $i < count($data['LocationID']); $i++)
        {
        	if ($_POST['location'.$data['LocationID'][$i].'_is_open'] == 1)
        	{
        		$template->setVariable('LocationID', $data['LocationID'][$i]);
        		$template->parse('if_submitted_location');
        	}
        }
    }
}
else
{
	if ($_GET['action'] == 'remove')
	{
		$group->GroupPicture = '';
		$data['GroupPicture'] = '';
		$group->saveToDB();
	}
}

foreach ($COUNTRIES as $key => $value)
{
	$template->setVariable('key', $key);
	$template->setVariable('value', $value);
	if ($key == $data['GroupCountry'])
	{
		$template->touchBlock('group_country_selected');
	}
	$template->parse('group_country');
}

foreach($STATES as $key => $value )
{
	$template->setVariable('key', $key);
	$template->setVariable('value', $value);
	if ($key == $data['GroupState'])
	{
		$template->touchBlock('group_state_selected');
	}
	$template->parse('group_state');
}

for ($i = 0; $i < count($data['LocationID']); $i++)
{
	$template->setVariable('LocationID',		$data['LocationID'][$i]);
	$template->setVariable('LocationName',		$data['LocationName'][$i]);
	$template->setVariable('LocationCountry',	$data['LocationCountry'][$i]);
	$template->setVariable('LocationStreet',	$data['LocationStreet'][$i]);
	$template->setVariable('LocationCity',		$data['LocationCity'][$i]);
	$template->setVariable('LocationState',		$data['LocationState'][$i]);

	foreach ($COUNTRIES as $key => $value)
	{
		$template->setVariable('key', $key);
		$template->setVariable('value', $value);
		if ($key == $data['LocationCountry'][$i])
		{
			$template->touchBlock('country_selected');
		}
		$template->parse('country');
	}

	foreach($STATES as $key => $value )
	{
		$template->setVariable('key', $key);
		$template->setVariable('value', $value);
		if ($key == $data['LocationState'][$i])
		{
			$template->touchBlock('state_selected');
		}
		$template->parse('state');
	}

	$template->parse('location');
}

for ($i = 0; $i < count($data['SocialGroupName']); $i++)
{
	$template->setVariable('SocialGroupName',	$data['SocialGroupName'][$i]);
	$template->setVariable('SocialGroupURL',	$data['SocialGroupURL'][$i]);
	$template->parse('other_social_group');
}

$template->setVariable(array_slice($data, 0, 15));
$template->setVariable('GroupID', $data['GroupID']);
if ($data['GroupPicture'])
{
	$template->setVariable('GroupPictureURL', PATH_GROUP_PICS . $data['GroupID'] . '/80px/' . $data['GroupPicture']);
}
else
{
	$template->setVariable("GroupPictureURL", 'images/img.jpg');
}

$template->setVariable(array(
	'public'	=> GROUP_STATUS_PUBLIC,
	'private'	=> GROUP_STATUS_PRIVATE,
	'closed'	=> GROUP_STATUS_CLOSED,
));

switch ($group->GroupStatus)
{
	case GROUP_STATUS_PUBLIC:	$template->touchBlock("groupstatus_public_checked");	break;
	case GROUP_STATUS_PRIVATE:	$template->touchBlock("groupstatus_private_checked");	break;
	case GROUP_STATUS_CLOSED:	$template->touchBlock("groupstatus_closed_checked");	break;
	default: $template->touchBlock("groupstatus_public_checked");
}

ApplicationContext::save();

include('includes/application_bottom.php');