<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 


final class ApplicationContext
{
	private static $instance = null;
	protected $lastVisitedPage = "";
	protected $lastVisitedUri = "";

	private function __construct()
	{
		if (isset($_SESSION['ApplicationContext']))
		{
			$this->lastVisitedPage = $_SESSION['ApplicationContext']['LastVisitedPage'];
			$this->lastVisitedUri = $_SESSION['ApplicationContext']['LastVisitedUri'];
		}
		else
		{
			$_SESSION['ApplicationContext'] = array();
			$_SESSION['ApplicationContext']['LastVisitedPage'] = "";
			$_SESSION['ApplicationContext']['LastVisitedUri'] = "";
		}
	}

	public static function initialize()
	{
		if (is_null(self::$instance))
		{
			self::$instance = new ApplicationContext();
		}
	}

	/**
	 * @return Context
	 */
	public static function getInstance()
	{
		self::initialize();
		return self::$instance;
	}

	public static function getLastVisitedPage()
	{
		$ctx = self::getInstance();
		return $ctx->lastVisitedPage;
	}

	public static function getLastVisitedUri()
	{
		$ctx = self::getInstance();
		return $ctx->lastVisitedUri;
	}

	public static function save()
	{
		if (!isset($_SESSION['ApplicationContext']))
		{
			$_SESSION['ApplicationContext'] = array();
		}
		$_SESSION['ApplicationContext']['LastVisitedPage'] = FILENAME;
		$_SESSION['ApplicationContext']['LastVisitedUri'] = $_SERVER['REQUEST_URI'];
	}
}