<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class BuddyList
{
	public static function getUsersFromPost($usevalues = true)
	{
		$return = array();
		if (isset($_POST['UserID']))
		{
            if ($usevalues)
            {
			    foreach ($_POST['UserID'] as $userID)
			    {
				    $user = new User($userID);
				    if ($user->UserID != -1)
				    {
					    $return[$user->UserID] = $user;
				    }
			    }
            }
            else
            {
                foreach ($_POST['UserID'] as $userID => $temp)
                {
                    $user = new User($userID);
                    if ($user->UserID != -1)
                    {
                        $return[$user->UserID] = $user;
                    }
                }
            }
		}
		return $return;
	}
	
	public function getSelectedUsers($usevalues = true)
	{
		return BuddyList::getUsersFromPost($usevalues);
	}
	
	public function __construct($template, $place, $userID, $title = '')
	{
		$tpl = new HTML_Template_Sigma(PATH_TEMPLATES, PATH_TEMPLATES_CACHE);
		$tpl->loadTemplateFile('control.buddylist.html');
		$tpl->setGlobalVariable('ListTitle', $title);
		tpl_set_common_functions($tpl);
		
	    $connGroups = Connection::getConnections(array('UserID' => $userID, 'GroupID' => '<> -1', 
    		'ConnectionType' => array(CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER)), 
    		array('Created'));
	    
	    foreach ($connGroups as $connGroup)
	    {
    		$group = $connGroup->getGroup();
		    
		    $connUsers = Connection::getConnections(array('UserID' => '<> -1', 'GroupID' => $group->GroupID, 
    			'ConnectionType' => array(CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER)), 
    			array('Created'));
    		
    		foreach ($connUsers as $connUser)
    		{
    			$member = $connUser->getTarget($group);
    			$tpl->setVariable('GroupID', $group->GroupID);

    			$tpl->setVariable('UserID', $member->UserID);
    			$tpl->setVariable('UserFirstname', $member->UserFirstname);
    			$tpl->setVariable('UserLastname', $member->UserLastname);
    			$tpl->parse('individual');
    		}
    		
    		$tpl->setVariable('GroupID', $group->GroupID);
    		$tpl->setVariable('GroupName', $group->GroupName);
    		
    		$tpl->parse('group');
		}    
        $db = DBConnect::getInstance();
        $result = $db->query('select * from `connection` where ' . 
            'ConnectionType = %d and UserID = %d', 
            CONNECTIONTYPE_BUDDY, $userID, $userID);
		
        $user = new User($userID);
        foreach ($result->Data as $row)
        {
            $connection = new Connection();
            $connection->populateFromArray($row);
            $target = $connection->getTarget($user);
            $tpl->setVariable('UserID', $target->UserID);  
            $tpl->setVariable('UserFirstname', $target->UserFirstname);
            $tpl->setVariable('UserLastname', $target->UserLastname);
            $tpl->parse('buddy');
        }
		$template->setVariable($place, $tpl->get());
	}
}
?>