<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class BlogComment extends Entity
{
	public $BlogCommentID		= -1;
	public $BlogEntryID			= -1;
	public $UserID				= -1;
	public $BlogCommentDate		= CURRENT_TIME;
	public $BlogCommentMessage	= '';

	public static function getBlogEntryComments($blogEntryID)
	{
		$return = array();

		$db = DBConnect::getInstance();
		$result = $db->query('select * from blogcomment where BlogEntryID = %d', $blogEntryID);
		foreach ($result->Data as $row)
		{
			$comment = new BlogComment();
			$comment->populateFromArray($row);

			$return[] = $comment;
		}

		return $return;
	}

	public function saveToDB()
	{
		parent::saveToDB();
	}

	public static function getNewUserBlogCommentsCount($userID)
	{
		$db = DBConnect::getInstance();
		$result = $db->query('SELECT COUNT(*) AS bc FROM `blogcomment` WHERE (UserID = %d) AND (DATEDIFF(CURDATE(), BlogCommentDate) <= %d)', $userID, PROFILE_UPDATE_PERIOD);
		return $result->Data[0]['bc'];
	}

	public function getUser()
	{
		return new User($this->UserID);
	}
}
?>