<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class FormSubmission Extends Entity
{
	public $FormSubmissionID		= -1;
	public $UserID					= -1;
	public $FormID					= -1;
	public $FormFieldID				= -1;
	public $FormFieldValue			= '';
	public $FormFieldOptionID		= -1;
	public $FormSubmissionStatus	= FORM_SUBMISSION_STATUS_PENDING;
	public $FormSubmissionDate		= CURRENT_TIME;


    public function getFormSubmissions($form_id)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $query = $db->query("SELECT FormSubmissionID, UserID, FormID, FormSubmissionStatus, FormSubmissionDate FROM `formsubmission` WHERE FormID = %d AND FormSubmissionStatus = %d GROUP BY FormID, UserID", $form_id, FORM_SUBMISSION_STATUS_SUBMITTED);

        foreach ($query->Data as $row)
        {
            $submission = new FormSubmission();
            $submission->populateFromArray($row);
            $result[] = $submission;
        }

        return $result;
	}

    public function getSubmittedFormFields($form_id, $user_id)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $query = $db->query("SELECT FormFieldID, FormFieldValue, FormFieldOptionID FROM `formsubmission` WHERE FormID = %d AND UserID = %d", $form_id, $user_id);

        foreach ($query->Data as $row)
        {
            $submission = new FormSubmission();
            $submission->populateFromArray($row);
            $result[] = $submission;
        }

        return $result;
	}

	public function getObligatorMembers($form_id)
	{
        $result = array();

        $db = DBConnect::getInstance();
        $query = $db->query("SELECT DISTINCT u.* FROM `user` AS u INNER JOIN `formsubmission` AS fs ON fs.UserID = u.UserID WHERE fs.FormID = %d AND fs.FormSubmissionStatus = %d", $form_id, FORM_SUBMISSION_STATUS_PENDING);

        foreach ($query->Data as $row)
        {
            $member = new User();
            $member->populateFromArray($row);
            $result[] = $member;
        }

        return $result;
	}
}
?>