<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class SharedFile Extends Entity
{
	public $SharedFileID	= -1;
	public $UserID 			= -1;
	public $GroupID 		= -1;
	public $OrganizationID 	= -1;
	public $CommunityID 	= -1;
	public $FileName		= '';
	public $FilePath		= './';
	public $FileMIMEType	= '';
	public $FileDescription	= '';
	public $Updated 		= CURRENT_TIME;


	public function getFileURL($preview = true)
	{
		$ext = $this->FileMIMEType;
		if (in_array($ext, array('gif', 'jpeg', 'jpg', 'png')))
		{
			$entity = $this->getOwnerEntityName();
			$entity_id = $this->getOwnerID();
			$tmp_path = PATH_TEMP_DIR . 'download/' . $entity . '/' . $entity_id;
			cmn_create_path($tmp_path);
			$dest_path = $tmp_path . '/' . $this->SharedFileID . '.' . $this->FileMIMEType;
			copy(PATH_DOWNLOAD_FILES . $entity . '/' . $this->getOwnerID() . '/' . $owner_id . $this->SharedFileID, $dest_path);
			return $dest_path;
		}
		if (file_exists(PATH_FILEICONS . $ext . '.png'))
		{
			return PATH_FILEICONS . $ext . '.png';
		}
		else
		{
			return PATH_FILEICONS . 'generic.png';
		}

	}

    public function getOwner()
    {
    	global $user;
        $result = $user;

        if ($this->OrganizationID != -1)
        {
            $result = new Organization($this->OrganizationID);
        }
        elseif ($this->GroupID != -1)
        {
            $result = new Group($this->GroupID);
        }
        elseif ($this->UserID != -1)
        {
            $result = new User($this->UserID);
        }

        return $result;
    }

    public function getOwnerID()
    {
    	$owner = $this->getOwner();
    	return $owner->{db_get_entity_key($owner)};
    }

    public function getOwnerEntityName()
    {
    	return strtolower(get_class($this->getOwner()));
    }

    public function getTags()
    {
    	return Tag::getTags(TAG_TYPE_SHARED_FILE, $this->SharedFileID);
    }

    public static function getUserFiles($user_id)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $query = $db->query("SELECT * FROM `sharedfile` WHERE UserID = %d", $user_id);
        foreach ($query->Data as $row)
        {
            $file = new SharedFile();
            $file->populateFromArray($row);
            $result[] = $file;
        }

        return $result;
    }

    public static function getCommunityFiles($community_id)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $query = $db->query('SELECT * FROM `sharedfile` WHERE CommunityID = %d', $community_id);
        foreach ($query->Data as $row)
        {
            $file = new SharedFile();
            $file->populateFromArray($row);
            $result[] = $file;
        }

        return $result;
    }

    public static function getGroupFiles($group_id)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $query = $db->query('SELECT * FROM `sharedfile` WHERE GroupID = %d', $group_id);
        foreach ($query->Data as $row)
        {
            $file = new SharedFile();
            $file->populateFromArray($row);
            $result[] = $file;
        }

        return $result;
    }

    public static function getOrganizationFiles($organization_id)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $query = $db->query('SELECT * FROM `sharedfile` WHERE OrganizationID = %d', $organization_id);
        foreach ($query->Data as $row)
        {
            $file = new SharedFile();
            $file->populateFromArray($row);
            $result[] = $file;
        }

        return $result;
    }

    public function checkUserPermissions($user_id)
    {
        $object = $this->getOwner();

    	switch ( strtolower(get_class($object)) )
        {
			case 'user':
				$result = $object->hasBuddy($user_id);
				break;
			case 'group':
			case 'organization':
				$result = true;//$object->hasMember($user_id);
				break;
		}

		return $result;
	}

	public function delete()
	{
        $file_path = '';
		find_file(PATH_DOWNLOAD_FILES, $this->SharedFileID, $file_path);
		@unlink($file_path);
        parent::delete();
	}

	public function getFileSize()
	{
		return filesize($this->FilePath);
	}

	public static function getUserSharedFilesCount($user_id)
	{
		$db = DBConnect::getInstance();
		$result = $db->query('SELECT COUNT(*) AS cnt FROM `sharedfile` WHERE UserID = %d', $user_id);
		return $result->Data[0]['cnt'];
	}

	public static function getAllSharedFilesCount()
	{
		$db = DBConnect::getInstance();
		$result = $db->query('SELECT COUNT(*) AS cnt FROM `sharedfile`');
		return $result->Data[0]['cnt'];
	}

    public static function getUserFilesSize($userID)
    {
        $size = 0;
        $db = DBConnect::getInstance();
        $query = $db->query('SELECT * FROM sharedfile WHERE UserID = %d', $userID);
        foreach ($query->Data as $row)
        {
            $obj = new SharedFile();
            $obj->populateFromArray($row);
            $size += filesize($obj->getFileURL(true)) + filesize($obj->getFileURL(false));
        }
        return $size;
    }
}
?>