<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class SocialGroup extends Entity
{
	public $SocialGroupID	= -1;
	public $GroupID 		= -1;
	public $UserID	 		= -1;
	public $OrganizationID	= -1;
	public $SocialGroupName	= '';
	public $SocialGroupURL	= '';


	public static function getUserSocialGroups($user_id)
	{
		$result = array();

		$db = DBConnect::getInstance();
		$res = $db->query("SELECT * from `socialgroup` WHERE `UserID`=%s", $user_id);

		foreach ($res->Data as $row)
		{
			$other_social_group = new SocialGroup();
			$other_social_group->populateFromArray($row);
			$result[] = $other_social_group;
		}

		return $result;
	}

	public static function getOtherSocialGroups($group_id = -1)
	{
		$result = array();

		$db = DBConnect::getInstance();
		$res = $db->query("SELECT * from `socialgroup` WHERE `GroupID`=%s", $group_id);

		foreach ($res->Data as $row)
		{
			$other_social_group = new SocialGroup();
			$other_social_group->populateFromArray($row);
			$result[] = $other_social_group;
		}

		return $result;
	}

	public static function getOrganizationSocialGroups($organization_id)
	{
		$result = array();

		$db = DBConnect::getInstance();
		$res = $db->query("SELECT * from `socialgroup` WHERE OrganizationID=%s", $organization_id);

		foreach ($res->Data as $row)
		{
			$social_group = new SocialGroup();
			$social_group->populateFromArray($row);
			$result[] = $social_group;
		}

		return $result;
	}

	public static function clearUserSocialGroups($user_id)
	{
		$db = DBConnect::getInstance();
		$db->delete('socialgroup', 'UserID = %d', $user_id);
	}

	public static function clearOtherSocialGroups($group_id)
	{
		$db = DBConnect::getInstance();
		$db->delete('socialgroup', 'GroupID = %d', $group_id);
	}

	public static function clearOrganizationSocialGroups($organization_id)
	{
		$db = DBConnect::getInstance();
		$db->delete('socialgroup', 'OrganizationID = %d', $organization_id);
	}
}
?>