<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

function cmn_split_text_10($matches)
{
    return wordwrap($matches[1], 10, ' ', 1);
}

function cmn_split_text($matches)
{
    return wordwrap($matches[1], 40, ' ', 1);
}

function cmn_unathorized_action($return = false)
{
	if ($return)
	{
		setcookie('ReturnURL', urlencode($_SERVER['REQUEST_URI']));
	}
	cmn_redirect('index.php');
}

function cmn_collect_objects($entity, $data)
{
	$return = array();
	foreach ($data as $row)
	{
		$obj = Entity::getObject($entity);
		$obj->populateFromArray($row);
		$return[$entity . ':' . $obj->{db_get_entity_key($obj)}] = $obj;
	}
	return $return;
}


function cmn_redirect($location)
{
	header('Location: ' . $location);
	echo '<script> location.href =\'' . $location . '\';</script>';
	exit();
}

function cmn_unauthorized_action($return = false)
{
	if ($return)
	{
		setcookie('ReturnURL', urlencode($_SERVER['REQUEST_URI']));
	}
	cmn_redirect('index.php?param=' . $return);
}

function cmn_create_path($path, $clear = true, $rights = 0755)
{
	if (!@is_dir($path))
	{
	    if(!@mkdir($path, $rights, true))
	    	die('Directory cannot be created: ' . $path . '; ' . getcwd());
	}
	else
	{
		@chmod($path, $rights);
		if ($clear)
		{
			$dirHandler = @opendir($path);
			while (($file = @readdir($dirHandler)) !== false)
		    {
				if ($file != "." && $file != "..")
		        {
					@unlink($path . "/" . $file);
		        }
		    }
		    closedir($dirHandler);
		}
	}
}

function cmn_get_manage_link($entity, $id)
{
	switch ($entity)
	{
		case 'Organization':
			return 'organization.php?organization_id=' . $id;

		case 'Community':
			return 'community.php?community_id=' . $id;

		case 'Group':
			return 'group.php?group_id=' . $id;

        case 'User':
            return 'member.php?user_id=' . $id;

	}

	return '#';
}

function cmn_get_profile_link($entity, $id)
{
	switch (ucfirst($entity))
	{
		case 'Organization':
			return 'organization.php?organization_id=' . $id;

		case 'Community':
			return 'community.php?community_id=' . $id;

		case 'User':
			return 'member.php?member_id=' . $id;

		case 'Group':
			return 'group.php?group_id=' . $id;
	}

	return '#';
}

function cmn_self_link($argument = '', $argvalue = '', $ignore = array())
{
	$arguments = array();

	foreach ($_GET as $key => $value)
	{
		if ((array_search($key, $ignore) === false) && ($key != $argument))
		{
			$arguments[] = $key . '=' . $value;
		}
	}

	if (!empty($argument))
	{
		$arguments[] = $argument . '=' . $argvalue;
	}

	return FILENAME . '?' . implode('&', $arguments);
}

function cmn_search_header_img()
{
	return false;
}

function cmn_remove_directory($path)
{
    $dirHandler = @opendir($path);
    while (($file = @readdir($dirHandler)) !== false)
    {
        if ($file != "." && $file != "..")
        {
            @unlink($path . "/" . $file);
        }
    }
    @closedir($dirHandler);
    @rmdir($path);
}

function cmn_generate_password($length = 8)
{
	$result = "";
	$i = 0;
	$alphabet = PASSWORD_RECOVERY_ALPHABET;
	while ($i < $length)
	{
		$char = substr($alphabet, mt_rand(0, strlen($alphabet) - 1), 1);
		if (!strstr($result, $char))
		{
			$result .= $char;
			$i++;
		}
	}
	return $result;
}

function cmn_upload_file($origin, $dest, $tmp_name)
{
  $origin = strtolower(basename($origin));
  $fulldest = $dest.$origin;
  $filename = $origin;
  for ($i=1; file_exists($fulldest); $i++)
  {
    $fileext = (strpos($origin,'.')===false?'':'.'.substr(strrchr($origin, "."), 1));
    $filename = substr($origin, 0, strlen($origin)-strlen($fileext)).'['.$i.']'.$fileext;
    $fulldest = $dest.$newfilename;
  }

  if (move_uploaded_file($tmp_name, $fulldest))
    return $filename;
  return false;
}

// Check if the file exists (in subfolders too)
function find_file($dirname, $fname, &$file_path)
{
  $dir = opendir($dirname);

  while ($file = readdir($dir))
  {
  	  if (empty($file_path) && $file != '.' && $file != '..')
  	  {
  	  	  if (is_dir($dirname.'/'.$file))
  	  	  {
  	  	  	  find_file($dirname.'/'.$file, $fname, $file_path);
  	  	  }
  	  	  else
  	  	  {
  	  	  	  if (file_exists($dirname.'/'.$fname))
  	  	  	  {
  	  	  	  	  $file_path = $dirname.'/'.$fname;
  	  	  	  	  return;
  	  	  	  }
  	  	  }
  	  }
  }
}

?>