<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'home';
require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

// administrator stuff
if (isset($_GET['user_id']) && User::checkEmployer($_SESSION['user']->UserID))
{
    $user = new User($_GET['user_id']);
    $_SESSION['admin_rule'] = $user;
    cmn_redirect('member.php'); // re-process header blocks and menu
}

if (is_numeric($_GET['member_id']))
{
	$memberid = $_GET['member_id'];
}
else
{
	$memberid =  $user->UserID;
}
$member = new User($memberid);

if ($member->isBlocked($user))
{
	cmn_unauthorized_action();
}

$template->setGlobalVariable('SectionHeader', db_get_entity_display_name($member) . ' Homepage');

if (Session::isUserLoggedIn($member->UserID))
{
	$session = Session::getUserSession($member->UserID);

	if ($_POST['UserOnlineStatus'])
	{
		$session->UserOnlineStatus = $_POST['UserOnlineStatus'];
		$session->UserAwayMessage = $_POST['UserAwayMessage'];
		$session->UserOnlineStatusOther = $_POST['UserOnlineStatusOther'];
		$session->saveToDB();
	}


	if ($session->UserOnlineStatus == USER_ONLINE_STATUS_ONLINE)
	{
		$template->setVariable('UserOnlineStatus', 'Online Now');
	}
	elseif ($session->UserOnlineStatus == USER_ONLINE_STATUS_AWAY)
	{
		$template->setVariable('UserOnlineStatus', 'Away');
		if (strlen($session->UserAwayMessage) > 0)
		{
			$template->setVariable('UserAwayMessage', $session->UserAwayMessage);
			$template->parse('away_message');
		}
	}
	else
	{
		$template->setVariable('UserOnlineStatus', $session->UserOnlineStatusOther);
	}
	$template->touchBlock('online_status');
	$template->parse('online_status');
}

$template->setVariable('MemberFirstName', $member->UserFirstname);
$template->setVariable('MemberLastName', $member->UserLastname);

if ($member->UserID != $user->UserID)
{
	$template->touchBlock('contact_preferences');
	if (!Connection::checkUserPrivacyAccessPrivilegies(PRIVACY_FLAG_PERSONAL_INFO, $member->UserID, $user->UserID))
	{
		$template->hideBlock('contact_info'); 
	}
	if (!Connection::checkUserPrivacyAccessPrivilegies(PRIVACY_FLAG_OTHER_CONTACTS, $member->UserID, $user->UserID))
	{
		$template->hideBlock('other_contacts');
	}
	if (!Connection::checkUserPrivacyAccessPrivilegies(PRIVACY_FLAG_OTHER_GROUPS, $member->UserID, $user->UserID))
	{
		$template->hideBlock('other_groups');
	}
	else
	{
		$template->touchBlock('other_groups');
	}
	if (!Connection::checkUserPrivacyAccessPrivilegies(PRIVACY_FLAG_FAVOURITES, $member->UserID, $user->UserID))
	{
		$template->hideBlock('favorites');
	}
	if (!Connection::checkUserPrivacyAccessPrivilegies(PRIVACY_FLAG_SKILLS, $member->UserID, $user->UserID))
	{
		$template->hideBlock('skills');
	}
	else
	{
		$template->touchBlock('skills');
	}
}
else
{
	$template->touchBlock('other_groups');
	$template->touchBlock('skills');
}

$template->setGlobalVariable('UserID', $member->UserID);

if ($member->UserPicture != '')
{
	$template->setVariable('UserPicture', $member->UserPicture);
}
else
{
	$template->touchBlock('no_avatar');
}

$template->setGlobalVariable('UserID', $member->UserID);

// connections

$connections = $member->getConnections(array('GroupID' => '<> -1',
	'ConnectionType' => array(CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER)),
	array('Created'));

$template->setVariable('GroupsCount', count($connections));

for ($i = 0; $i < count($connections) && $i < 10; $i++)
{
    $connection = $connections[$i];
	$group = $connection->getGroup();
	$template->setVariable('GroupID', $group->GroupID);
	$template->setVariable('GroupName', $group->GroupName);
	if ( ( ($connection->ConnectionType == CONNECTIONTYPE_OWNER) || ($connection->ConnectionType == CONNECTIONTYPE_ADMIN) ) && $user->UserID == $member->UserID)
	{
		$template->touchBlock('group_manage');
	}

	$template->parse('group');
}

$connections = $member->getConnections(array('ToUserID' => '<> -1',
	'ConnectionType' => CONNECTIONTYPE_BUDDY), array('Created'));

$template->setVariable('IndividualsCount', count($connections));
for ($i = 0; $i < count($connections) && $i < 10; $i++)
{
    $connection = $connections[$i];
	$buddy = $connection->getTarget($member);
	$template->setVariable('BuddyID', $buddy->UserID);
	$template->setVariable('BuddyFirstname', $buddy->UserFirstname);
	$template->setVariable('BuddyLastname', $buddy->UserLastname);
	$template->parse('individual');
}

$template->setVariable('member_name', $member->UserFirstname.' '.$member->UserLastname);
$template->setVariable('member_email', $member->UserEmail);
$template->setVariable('member_phone', $member->UserPhone);

/*
foreach (array(1, 2, 4, 8, 16) as $value)
{
	if (($member->UserInterests & $value) == $value)
	{
		$template->touchBlock('UserInterests_' . $value);
	}
}

$template->setVariable('member_interests_other', $member->UserInterestsOther);
*/

if ($member->canSeeFavorites($user->UserID) == true)
{
	if (!empty($member->UserFavouriteBooks))
	{
		$template->setVariable('member_book', 		$member->UserFavouriteBooks);
		$template->parse("favourite_books");
	}
	if (!empty($member->UserFavouriteMovies))
	{
		$template->setVariable('member_film', 		$member->UserFavouriteMovies);
		$template->parse("favourite_films");

	}
	if (!empty($member->UserFavouriteActivities))
	{
		$template->setVariable('member_activities',	$member->UserFavouriteActivities);
		$template->parse("favourite_activities");
	}
	if (!empty($member->UserFavouriteWebsites))
	{
		$template->setVariable('member_websites',	eregi_replace(
			'((https?\:\/\/)?((www\.)?[^ \.]+\.(biz|info|com|org|net|ru)))',
			'<a href="http://\3">\1</a>', $member->UserFavouriteWebsites));
		$template->parse("favourite_wesites");
	}
	if (!empty($member->UserFavouriteFood))
	{
		$template->setVariable('member_food', 		$member->UserFavouriteFood);
		$template->parse("favourite_food");
	}
	if (!empty($member->UserFavouriteInterests))
	{
		$template->setVariable('member_interests', 	$member->UserFavouriteInterests);
		$template->parse("my_interests");
	}
	//$template->setVariable('member_activities', $member->UserFavouriteActivities);
}
else
{
	$template->setVariable('member_book', 		'private info');
	$template->setVariable('member_film', 		'private info');
	$template->setVariable('member_food', 		'private info');
	$template->setVariable('member_interests', 	'private info');
	$template->setVariable('member_activities', 'private info');
}

if ($member->canSeeEducation($user->UserID) == true)
{
	$schools = $member->getSchools();
	foreach ($schools as $school)
	{
		if ($school->SchoolStartDate)
		{
			$date1 = strtotime($school->SchoolStartDate);
			$date1 = date("m/y", $date1);
		}
		$date2 = strtotime($school->SchoolEndDate);
		if ($school->SchoolEndDate)
		{

			$date2 = date("m/y", $date2 );
		}
		else
		{
			$date2 = "present";
		}
		$template->setVariable('member_education', $school->SchoolName . ' (' . $school->SchoolDescription . '), ' . $date1.' - '.$date2 . '<br/>');
		$template->parse('school');
	}
}
if ($member->canSeeWork($user->UserID) == true)
{
	$companies = $member->getCompanies();
	foreach ($companies as $company)
	{
		if ($company->CompanyStartDate)
		{
			$date1 = strtotime($company->CompanyStartDate);
			$date1 = date("Y",$date1);
		}
		$date2 = strtotime($company->CompanyEndDate);
		if ($company->CompanyEndDate)
		{
			$date2 = date("m/y",$date2);
		} else
		{
			$date2 = "present";
		}
		$template->setVariable('member_work', $company->CompanyUserTitle.', '.$company->CompanyName . ' (' . $company->CompanyDescription . '), ' . $date1.' - '.$date2 . '<br/>');
		$template->parse('company');
	}
}

$events = $member->getUpcomingEvents(7);

if (!empty($events) && $member->checkCalendarPrivacy($user->UserID))
{
	foreach ($events as $event)
	{
		$owner = $event->getOwner();

		if ($owner->checkCalendarPrivacy($user->UserID))
		{
		    $begin_date = strtotime($event->EventStartDate);
		    $begin_time = date("g:i A", $begin_date);
		    $begin_date = date("F, d", $begin_date);
		    $template->setVariable('event_date', $begin_date);
		    $template->setVariable('event_id', $event->EventID);
		    $template->setVariable('event_time', $begin_time);
		    $template->setVariable('event_name', $event->EventName);
		    $template->parse('event');
		}
	}
	$template->touchBlock('all_events_link');
}
else
{
	$template->touchBlock('no_events');
}

if (!UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_MEDIA))
{
	$photos = $member->getPhotos(6);
	if (!empty($photos) && count($photos)>0)
	{
	    foreach ($photos as $photo)
	    {
	        $album = new Album($photo->AlbumID);
	    	if ($album->checkPermission('view'))
	        {
		    	$template->setVariable(get_object_vars($photo));
		        $template->setVariable('PhotoID', $photo->PhotoID);
		        $template->setVariable('PhotoURL', $photo->getPhotoURL(true));
		        $template->setVariable('PhotoName', $photo->PhotoName);
		        $template->parse('photos');
	        }
	    }
	    $template->touchBlock('all_photos_link');
	}
	else
	{
		$template->touchBlock('no_photo');
	}

    $videos = $member->getVideos(6);
    if (!empty($videos) && count($videos)>0)
    {
	    foreach ($videos as $video)
	    {
	        $template->setVariable(get_object_vars($video));
	        $template->setVariable('VideoURL', $video->getVideoURL());
	        $template->parse('videos');
	    }
	    $template->touchBlock('all_videos_link');
    }
	else
	{
		$template->touchBlock('no_video');
	}

    $files = $member->getSharedFiles(6);
    //cmn_remove_directory(PATH_TEMP_DIR . 'download/user/' . $member->UserID);
    if (!empty($files) && count($files)>0)
    {
	    foreach ($files as $file)
	    {
	        $template->setVariable(get_object_vars($file));
	        $template->setVariable('SharedFileURL', $file->getFileURL());
	        $template->parse('files');
	    }
	    $template->touchBlock('all_files_link');
    }
    else
    {
    	$template->touchBlock('no_files');
    }

    /*
    $files = $member->getFiles(6);
    foreach ($files as $file)
    {
        $template->setVariable(get_object_vars($file));
        $template->setVariable('FileURL', $file->getFileURL());
        //$template->parse('side_albums');
        $template->parse('files');
    }
    */
    $template->touchBlock('media');
}

if ($user->UserID == $member->UserID)
{
	$template->touchBlock('add_event_link');
	//$template->touchBlock('add_album_link');
	$template->touchBlock('add_photos_link');
	$template->touchBlock('add_videos_link');
	$template->touchBlock('add_files_link');
}

// my other social groups
$other_social_groups = $member->getUserSocialGroups();
foreach ($other_social_groups as $social_group)
{
    $template->setVariable('GroupName', $social_group->SocialGroupName);
    $template->setVariable('GroupURL',	eregi_replace(
		'((https?\:\/\/)?((www\.)?[^ \.]+\.(biz|info|com|org|net|ru)))',
		'<a href="http://\3">\1</a>', $social_group->SocialGroupURL));
    $template->parse('social_group');
}



// my skills
$skills = $member->getSkills();
foreach ($skills as $skill)
{
	$template->setVariable('SkillName', $skill->SkillName);
	$template->parse('skill');
}



// my other contacts
$template->setVariable('UserYahoo', $member->UserYahoo);
$template->setVariable('UserSkype', $member->UserSkype);
$template->setVariable('UserMSN', $member->UserMSN);
$template->setVariable('UserAOL', $member->UserAOL);

// new connection people statistics
$new_connection_people = count($member->getConnectedUsers());
$individuals_count = User::getAllUsersCount();

$rank = $individuals_count > 0 ? sprintf("%d", $new_connection_people / $individuals_count * 100) : 0;
$template->setVariable('NewConnectionPeople', $new_connection_people);
$template->setVariable('NewConnectionPeopleRank', $rank);

// member blog posts statistics
$template->setVariable('BlogPostsCount', $member->getBlogEntryCount());
$template->setVariable('BlogPostsRank', $member->getBlogEntryRank());

// member files uploaded statistics
$template->setVariable('FilesUploadedCount', $member->getSharedFilesCount());
$template->setVariable('FilesUploadedRank', $member->getSharedFilesRank());

// forum posts statistics
$forum_posts_count = forum_get_posts_count($member->UserEmail);
$forum_all_posts = forum_get_all_posts();
$rank = $forum_all_posts > 0 ? sprintf("%d", $forum_posts_count / $forum_all_posts * 100): 0;
$template->setVariable('ForumPostsCount', $forum_posts_count);
$template->setVariable('ForumPostsRank', $rank);

// tags statistics
$tags_count = count($member->getTags());
$all_tags = count(Tag::getAll('Tag'));
$rank = $all_tags > 0 ? sprintf("%d", $tags_count / $all_tags * 100) : 0;
$template->setVariable('TagsCount', $tags_count);
$template->setVariable('TagsRank', $rank);

// photo/video uploads statistics
$photo_video_count = $member->getVideoCount() + $member->getPhotoCount();
$all_photo_videos = count(Photo::getAll('Photo')) + count(Video::getAll('Video'));
$rank = $all_photo_videos > 0 ? sprintf("%d", $photo_video_count / $all_photo_videos * 100) : 0;
$template->setVariable('PhotosVideosCount', $photo_video_count);
$template->setVariable('PhotosVideosRank', $rank);

// comments statistics
$comments_count = count($member->getComments());
$all_comments = count(Comment::getAll('Comment'));
$rank = $all_comments > 0 ? sprintf("%d", $comments_count / $all_comments * 100) : 0;
$template->setVariable('CommentsCount', $comments_count);
$template->setVariable('CommentsRank', $rank);

$template->setVariable('UserForumID', $user->UserForumID);

if ($member->UserID == $user->UserID)
{
	$template->touchBlock('update_status_link');
	$template->touchBlock('contact_preferences');
}
else
{
	$template->hideBlock('contact_preferences');
}


function parseConnection($tpl, $row)
{
	global $member;

	if ($row['Entity'] == 'Organization')
	{
		$org = new Organization($row['ID']);
		if ($org->OrganizationStatus == ORGANIZATION_STATUS_EMPLOYER)
		{
			$tpl->setVariable('OrganizationID', $org->OrganizationID);
			$tpl->parse('resume');
		}
	}

	if ($row['Entity'] == 'Group')
	{
		$tpl->setVariable('MembersLink', FILENAME . '?connection=group&cid=' . $row['ID'] . '&id=' . $member->UserID);
		$tpl->setVariable('MembersCount',
			count
			(
				Connection::getConnections
				(
					array
					(
						'ConnectionType'	=> array(CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_MEMBER),
						'UserID'			=> '<> -1',
						'GroupID'			=> $row['ID']
					)
				)
			)
		);

		$tpl->parse('size');
	}

	$filter = array
	(
		$row['Entity'] . 'ID'	=> $row['ID'],
		'ConnectionType'		=> array(CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_BUDDY)
	);

	if ($row['Entity'] != 'User')
	{
		$filter['UserID'] = '-1';
	}

	$connections = Connection::getConnections($filter);
	foreach ($connections as $connection)
	{
		$target = $connection->getTarget();

		$tpl->setVariable('ConnectionLink', FILENAME . '?id=' . $member->UserID .
			'&connection=' . strtolower(get_class($target)) . '&cid=' . $target->{db_get_entity_key($target)});
		$tpl->setVariable('ConnectionTitle', $target->{db_get_entity_name($target)});
		$tpl->parse('connection');
	}

	if (!count($connections))
	{
		$tpl->touchBlock('connections_none');
	}

	$obj = Entity::getObject($row['Entity'], $row['ID']);
	if ($obj->isBlocked())
	{
		$tpl->setVariable('UnblockID', $row['ID']);
		$tpl->setVariable('UnblockEntity', strtolower($row['Entity']));
		$tpl->parse('unblock');
	}

}

require_once('includes/application_bottom.php');