<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unathorized_action();
}

if (UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_MEDIA))
{
    cmn_unathorized_action();
}

$photo_id = $_GET['photo_id'] ? $_GET['photo_id'] : ($_POST['PhotoID'] ? $_POST['PhotoID'] : 0);
$photo = new Photo($_GET['photo_id']);
$album = $photo->getAlbum();
$admin_perms = $album->checkPermission('edit');

if ($photo->PhotoID != -1 && $album->checkPermission('view'))
{
	if (isset($_POST['AlbumID']) && $_POST['action'] == 'move_to_album')
	{
		$dest_album = new Album($_POST['AlbumID']);

		if ($dest_album->checkPermission('edit'))
		{
			@rename(PATH_ALBUM_PICS . $photo->AlbumID . '/previews/' . $photo->PhotoPath, PATH_ALBUM_PICS . $dest_album->AlbumID . '/previews/' . $photo->PhotoPath);
			@rename(PATH_ALBUM_PICS . $photo->AlbumID . '/original/' . $photo->PhotoPath, PATH_ALBUM_PICS . $dest_album->AlbumID . '/original/' . $photo->PhotoPath);
			@rename(PATH_ALBUM_PICS . $photo->AlbumID . '/' . $photo->PhotoPath, PATH_ALBUM_PICS . $dest_album->AlbumID . '/' . $photo->PhotoPath);

			$photo->AlbumID = $dest_album->AlbumID;
			$photo->PhotoIsCover = false;
			$photo->saveToDB();
			$album = $dest_album;
			$admin_perms = $album->checkPermission('edit');

		}
	}
	elseif ($_POST['action'] == 'edit_caption')
	{
		$photo->PhotoName = $_POST['PhotoName'];
		$photo->saveToDB();
	}

    $template->setGlobalVariable('PhotoAlbumID', $album->AlbumID);
    
    if ($album->GroupID != -1)
    {
        $template->setVariable('Entity', 'group');
        $template->setVariable('EntityID', $album->GroupID);
        $template->parse('back_link');
    }
    else if ($album->OrganizationID != -1)
    {
        $template->setVariable('Entity', 'organization');
        $template->setVariable('EntityID', $album->OrganizationID);
        $template->parse('back_link');
    }

	if ($admin_perms)
	{
		
		$template->touchBlock('photoadmin');
		$template->touchBlock('edit_caption');
		
		if ($_POST['action'] == 'edit')
		{
			$album->clearCover();
			$photo->PhotoIsCover = 1;
			$photo->saveToDB();
		}
		if ($_GET['action'] == 'delete_comment')
		{
			$comment = new Comment($_GET['comment_id']);
			if ($comment->CommentID != -1)
			{
				$comment->delete();
			}
		}
		if ($_GET['action'] == 'delete')
		{

			$photo->delete();
			cmn_redirect('photos.php?album_id=' . $photo->AlbumID);
		}
		//move to album
		$photo_album = new Album($photo->AlbumID);
		$album_owner = $photo_album->getOwner();
		$owner_albums = $album_owner->getAlbums();
		if (count($owner_albums))
		{
			foreach ($owner_albums as $owner_album)
			{
				$template->setVariable('AlbumID', $owner_album->AlbumID);
				$template->setVariable('AlbumName', $owner_album->AlbumName);
				if ($owner_album->AlbumID == $photo->AlbumID)
				{
					$template->setVariable('selected', 'selected');
				}
				$template->parse('move_to');
			}
		}

		if ($photo->PhotoIsCover)
		{
			$template->touchBlock('cover_photo');
		}
		else
		{
			$template->touchBlock('set_cover');
		}

	}
	if ($_POST['action'] == 'comment' && $_POST['CommentText'])
	{
		$comment = new Comment();
		$comment->PhotoID = $photo->PhotoID;
		$comment->CommentText = $_POST['CommentText'];
		$comment->UserID = $user->UserID;
		$comment->saveToDB();
	}

	$template->setVariable("ImgURL", $photo->getPhotoURL(false));
	$template->setGlobalVariable("PhotoID", $photo->PhotoID);
	$template->setGlobalVariable("PhotoName", $photo->PhotoName);
	
	$comments = $photo->getPhotoComments();
	foreach ($comments as $comment)
	{
		$template->setVariable('User_Name',    $comment['UserFirstname'] . " " . $comment['UserLastname']);
		$template->setVariable('CommentText', $comment['CommentText']);
		$template->setVariable('CommentID',   $comment['CommentID']);
		$template->parse('comment');
		if ($admin_perms)
		{
			$template->parse('delete_comment');
		}
	}

	$prev_id = $photo->getPrevPhotoID();
	if ($prev_id)
	{
		$template->setVariable('PrevPhotoID', $prev_id);
		$template->parse('prev_link');
	}

	$next_id = $photo->getNextPhotoID();
	if ($next_id)
	{
		$template->setVariable('NextPhotoID', $next_id);
		$template->parse('next_link');
	}

}
else
{
	cmn_unauthorized_action();
}

include('includes/application_bottom.php');